"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _chunkDFNQQYCUcjs = require('./chunk-DFNQQYCU.cjs');


var _chunkTZOPYZVRcjs = require('./chunk-TZOPYZVR.cjs');

// src/node/files-async.ts
var _promises = require('fs/promises');
var _path = require('path');
var _process = require('process'); var _process2 = _interopRequireDefault(_process);
async function getStatAsync(path) {
  try {
    return await _promises.stat.call(void 0, path);
  } catch (err) {
  }
}
async function getFingerprintAsync(path) {
  const stat2 = await getStatAsync(path);
  if (stat2 == null)
    return;
  const { mtimeMs, size } = stat2;
  return `${path}|${mtimeMs}|${size}`;
}
async function walkSyncAsync(rootFolder, subFolder = "", ignoreHidden = true) {
  let resultPaths = [];
  const paths = await _promises.readdir.call(void 0, _path.resolve.call(void 0, rootFolder, subFolder));
  if (paths != null && paths.length > 0) {
    for (let file of paths) {
      file = _path.join.call(void 0, subFolder, file);
      if (ignoreHidden && _chunkDFNQQYCUcjs.isHiddenPath.call(void 0, file))
        continue;
      const realFile = _path.join.call(void 0, rootFolder, file);
      const stat2 = await getStatAsync(realFile);
      if (stat2 && stat2.isDirectory())
        resultPaths = resultPaths.concat(await walkSyncAsync(rootFolder, file) || []);
      else
        resultPaths.push(file);
    }
  }
  return resultPaths;
}
async function filesAsync(opt = {}) {
  let {
    pattern,
    filter,
    basePath = _process2.default.cwd(),
    ignoreHidden = false
  } = opt;
  let paths = await walkSyncAsync(basePath, "", ignoreHidden);
  paths = paths.filter(
    (path) => !(ignoreHidden && (path.startsWith(".") || path.includes("/.")))
  );
  if (pattern) {
    if (typeof pattern === "string")
      pattern = _chunkTZOPYZVRcjs.globToRegExp.call(void 0, pattern);
    if (pattern instanceof RegExp) {
      const rx = pattern;
      rx.lastIndex = 0;
      paths = paths.filter((path) => rx.test(path));
    }
  }
  if (filter)
    paths = paths.filter(filter);
  return paths;
}






exports.getStatAsync = getStatAsync; exports.getFingerprintAsync = getFingerprintAsync; exports.walkSyncAsync = walkSyncAsync; exports.filesAsync = filesAsync;
//# sourceMappingURL=chunk-4LQFWCWE.cjs.map