"use strict";Object.defineProperty(exports, "__esModule", {value: true});// src/common/data/orderby.ts
function parseOrderby(value = "") {
  let [field = "", orderby = "asc"] = value.split(" ");
  orderby = orderby.toLowerCase();
  return {
    field,
    orderby,
    asc: orderby !== "desc",
    desc: orderby === "desc"
  };
}
function composeOrderby(field, asc = true) {
  return `${field} ${asc ? "asc" : "desc"}`;
}
function cmp(a, b, asc = true) {
  const aa = a || 0;
  const bb = b || 0;
  return aa > bb ? asc ? 1 : -1 : aa < bb ? asc ? -1 : 1 : 0;
}
function sortedOrderby(values, ...orderby) {
  if (orderby.length > 0) {
    const orderByList = orderby.map(parseOrderby);
    const sortValues = Array.from(values);
    sortValues.sort((a, b) => {
      for (const { field, asc } of orderByList) {
        const result = cmp(a[field], b[field], asc);
        if (result !== 0)
          return result;
      }
      return 0;
    });
    return sortValues;
  }
  return values;
}






exports.parseOrderby = parseOrderby; exports.composeOrderby = composeOrderby; exports.cmp = cmp; exports.sortedOrderby = sortedOrderby;
//# sourceMappingURL=chunk-6T6PI6XG.cjs.map