"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }

var _chunkYY4AHBBLcjs = require('./chunk-YY4AHBBL.cjs');

// src/common/data/utils.ts
function ensureKey(obj, key, createFn) {
  let value = obj[key];
  if (value === void 0) {
    value = createFn(key, obj);
    obj[key] = value;
  }
  return value;
}
async function ensureKeyAsync(obj, key, createFn) {
  let value = obj[key];
  if (value === void 0) {
    value = await createFn(key, obj);
    obj[key] = value;
  }
  return value;
}
function size(obj) {
  if (obj != null) {
    if (obj.size != null)
      return obj.size;
    if (obj.length != null)
      return obj.length;
    return Object.keys(obj).length;
  }
  return 0;
}
function first(array) {
  return array != null && array.length > 0 ? array[0] : void 0;
}
function last(array) {
  return array != null && array.length > 0 ? array[array.length - 1] : void 0;
}
function empty(value) {
  try {
    if (value != null) {
      if (Array.isArray(value))
        return value.length <= 0;
      else if (typeof value === "string")
        return value.length <= 0;
      else if (_optionalChain([value, 'optionalAccess', _ => _.size]) != null)
        return value.size <= 0;
      else
        return Object.keys(value).length <= 0;
    }
  } catch (err) {
    console.warn("Failed to check if empty for", value, err);
  }
  return true;
}
function cloneObject(obj) {
  if (Object(obj) !== obj)
    return obj;
  return JSON.parse(_chunkYY4AHBBLcjs.jsonStringifySafe.call(void 0, obj));
}
function cloneJsonObject(obj) {
  if (Object(obj) !== obj)
    return obj;
  return JSON.parse(_chunkYY4AHBBLcjs.jsonStringifySafe.call(void 0, obj));
}
function memoize(fn) {
  const cache = /* @__PURE__ */ new Map();
  return (n) => {
    if (cache.has(n))
      return cache.get(n);
    const result = fn(n);
    cache.set(n, result);
    return result;
  };
}
function memoizeAsync(fn) {
  const cache = /* @__PURE__ */ new Map();
  return async (...n) => {
    const key = _chunkYY4AHBBLcjs.jsonStringifySafe.call(void 0, n);
    if (cache.has(key))
      return cache.get(key);
    const result = await fn(...n);
    cache.set(key, result);
    return result;
  };
}
function forTimes(count, fn) {
  const result = [];
  for (let i = 0; i < count; i++)
    result.push(fn(i, count));
  return result;
}













exports.ensureKey = ensureKey; exports.ensureKeyAsync = ensureKeyAsync; exports.size = size; exports.first = first; exports.last = last; exports.empty = empty; exports.cloneObject = cloneObject; exports.cloneJsonObject = cloneJsonObject; exports.memoize = memoize; exports.memoizeAsync = memoizeAsync; exports.forTimes = forTimes;
//# sourceMappingURL=chunk-W3WUDQIC.cjs.map