type BinInput = Uint8Array | ArrayBuffer | string | number[];
declare function _encodeUtf8Polyfill(str: string): Uint8Array;
declare function _decodeUtf8Polyfill(buf: Uint8Array): string;
declare function stringToUInt8Array(text: string): Uint8Array;
declare function Uint8ArrayToString(bin: Uint8Array): string;
declare function toUint8Array(data: BinInput): Uint8Array;
declare function joinToUint8Array(...args: BinInput[] | BinInput[][]): Uint8Array;
declare function toHex(bin: BinInput): string;
declare function fromHex(hexString: string): Uint8Array;
/** Regular base64 */
declare function toBase64(bin: BinInput, stripPadding?: boolean): string;
/** Converts `+` -> `-` and `/` -> `_`. Always strips `=` */
declare function toBase64Url(bin: BinInput): string;
/** Also parses toBase64Url encoded strings. */
declare function fromBase64(s: string): Uint8Array;
/** Also parses toBase64Url encoded strings. */
declare function fromBase64String(s: string): string;
/** Compare contents of binary arrays */
declare function equalBinary(a: ArrayBuffer | Uint8Array, b: ArrayBuffer | Uint8Array): boolean;
declare function jsonToUint8Array(json: any): Uint8Array | never;
declare function Uint8ArrayToJson<T = any>(data: Uint8Array): T | never;
declare function Uint8ArrayToHexDump(buffer: Uint8Array | ArrayBuffer | string | Array<number>, blockSize?: number): string | false;

export { type BinInput, Uint8ArrayToHexDump, Uint8ArrayToJson, Uint8ArrayToString, _decodeUtf8Polyfill, _encodeUtf8Polyfill, equalBinary, fromBase64, fromBase64String, fromHex, joinToUint8Array, jsonToUint8Array, stringToUInt8Array, toBase64, toBase64Url, toHex, toUint8Array };
