type SignalWatcher<T> = (value: T, oldValue: T) => void;
type Signal<T> = [
    () => T,
    (value: T) => void,
    (fn: SignalWatcher<T>) => () => void,
    (fn: SignalWatcher<T>) => void
] & {
    get: () => T;
    set: (value: T) => void;
    on: (fn: SignalWatcher<T>) => () => void;
    off: (fn: SignalWatcher<T>) => void;
};
/** Super simple signal implementation */
declare function useSignal<T = any>(value: T, onChange?: SignalWatcher<T>): Signal<T>;

export { type Signal, type SignalWatcher, useSignal };
