"use strict";


var _chunk7L2G4SFKcjs = require('../../chunk-7L2G4SFK.cjs');
require('../../chunk-XTDX3HZA.cjs');
require('../../chunk-4B2XCWGL.cjs');
require('../../chunk-ORGSTQ42.cjs');
require('../../chunk-5CIFX7O6.cjs');
require('../../chunk-LXSY24WI.cjs');
require('../../chunk-KMITBP74.cjs');
require('../../chunk-7BMZYEWF.cjs');
require('../../chunk-N46W55MH.cjs');
require('../../chunk-UKD65B23.cjs');
require('../../chunk-Y6KPVUVD.cjs');
require('../../chunk-J42M6DF3.cjs');
require('../../chunk-L646RZQB.cjs');
require('../../chunk-ZYPCVNSG.cjs');
require('../../chunk-VFIICDKU.cjs');
require('../../chunk-PDXKNB3S.cjs');
require('../../chunk-XR7AMYN7.cjs');
require('../../chunk-SLEHBFHV.cjs');
require('../../chunk-KMMN6P2X.cjs');
require('../../chunk-AGQV4BOO.cjs');
require('../../chunk-LURLRIHI.cjs');
require('../../chunk-67Q7IWIS.cjs');
require('../../chunk-B4JXPT6I.cjs');
require('../../chunk-KCBJGJ24.cjs');
require('../../chunk-RPAQV2V5.cjs');
require('../../chunk-SVJWXMAG.cjs');
require('../../chunk-RLHQ6YHC.cjs');
require('../../chunk-MPD2DJAD.cjs');
require('../../chunk-ZGKV237Z.cjs');
require('../../chunk-7BEQHGH5.cjs');
require('../../chunk-VAG3XY63.cjs');
require('../../chunk-FEYF6QXS.cjs');
require('../../chunk-SFVQNT7T.cjs');
require('../../chunk-N7OUNPMM.cjs');
require('../../chunk-Z4FNOCPD.cjs');
require('../../chunk-GWXPD6I7.cjs');



var _chunkN5KTMDVOcjs = require('../../chunk-N5KTMDVO.cjs');
require('../../chunk-B3U4FDQH.cjs');
require('../../chunk-YELWQAMG.cjs');
require('../../chunk-RHWKNEUH.cjs');
require('../../chunk-DRU33ZUG.cjs');
require('../../chunk-LHP7OTMV.cjs');


var _chunk5BF2LEAUcjs = require('../../chunk-5BF2LEAU.cjs');
require('../../chunk-6T6PI6XG.cjs');
require('../../chunk-TUWUD5A6.cjs');
require('../../chunk-CUGOCLWN.cjs');
require('../../chunk-W3WUDQIC.cjs');
require('../../chunk-BXM45HLQ.cjs');
require('../../chunk-HHZVPIBD.cjs');
require('../../chunk-YY4AHBBL.cjs');
require('../../chunk-IMCDDJAJ.cjs');

// src/common/msg/emitter.spec.ts
var _vitest = require('vitest');
function lazyListener(emitter, listenerKey) {
  const name = Math.round(_chunk5BF2LEAUcjs.getSecureRandomIfPossible.call(void 0, ) * 100);
  const events = [];
  let lazyResolve;
  const incoming = (key, obj) => {
    const ev = { key, obj };
    events.push(ev);
    lazyResolve && lazyResolve();
  };
  if (listenerKey) {
    if (emitter.on) {
      emitter.on(listenerKey, (obj) => {
        incoming(listenerKey, obj);
      });
    } else if (emitter.addEventListener) {
      emitter.addEventListener(listenerKey, (obj) => {
        incoming(listenerKey, obj);
      });
    } else {
      emitter.log.error(name, "Cannot listen to key");
    }
  } else {
    if (emitter.onAny) {
      emitter.onAny((key, obj) => {
        incoming(key, obj);
      });
    } else {
      emitter.log.error(name, "cannot listen to all for", emitter);
    }
  }
  const on = (key, skipUnmatched = true) => {
    return new Promise((resolve, reject) => {
      if (!key) {
        key = listenerKey;
        if (!key) {
          if (events.length) {
            key = events[0].key;
          }
        }
      }
      lazyResolve = () => {
        while (events.length > 0) {
          const ev = events.shift();
          if (ev.key === key) {
            lazyResolve = void 0;
            resolve(ev.obj);
          } else {
            if (skipUnmatched) {
              continue;
            }
            reject(new Error(`Expected ${key}, but found ${ev.key} with value=${ev.obj}`));
          }
          break;
        }
      };
      lazyResolve();
    });
  };
  return on;
}
describe("emitter", () => {
  it("should emit", async () => {
    expect.assertions(4);
    let ctr = 0;
    const e = new (0, _chunk7L2G4SFKcjs.Emitter)();
    e.on("test", (x, y) => expect(x + y).toBe(123));
    e.on("long", async () => {
      await _chunkN5KTMDVOcjs.sleep.call(void 0, 500);
      ctr++;
    });
    const ee = e.call;
    await ee.long();
    expect(ctr).toBe(1);
    e.onCall({
      test(x, y) {
        expect(x + y).toBe(123);
      }
    });
    await e.emit("long");
    expect(ctr).toBe(2);
    await e.emit("test", 100, 23);
  });
  it("should work", async () => {
    const e1 = new (0, _chunk7L2G4SFKcjs.Emitter)();
    const e2 = new (0, _chunk7L2G4SFKcjs.Emitter)();
    let counter = 99;
    e1.on("a", () => counter++);
    e2.on("a", () => counter--);
    e2.on("b", () => counter--);
    void e1.emit("a");
    expect(counter).toBe(100);
    void e2.emit("a");
    void e2.emit("b");
    expect(counter).toBe(98);
    e1.on("a", () => counter++);
    void e1.emit("a");
    expect(counter).toBe(100);
    e1.removeAllListeners();
    void e1.emit("a");
    expect(counter).toBe(100);
  });
  it("should wait on", async () => {
    expect.assertions(2);
    const e1 = new (0, _chunk7L2G4SFKcjs.Emitter)();
    setTimeout(() => {
      void e1.emit("f", 1);
    }, 100);
    const v = await _chunkN5KTMDVOcjs.waitOn.call(void 0, e1, "f");
    expect(v).toBe(1);
    await expect(_chunkN5KTMDVOcjs.waitOn.call(void 0, e1, "x", 10)).rejects.toThrow(
      "Did not response in time"
    );
  });
  it("should wait on integrated", async () => {
    expect.assertions(2);
    const e1 = new (0, _chunk7L2G4SFKcjs.Emitter)();
    queueMicrotask(() => {
      void e1.emit("f", 1);
    });
    const v = await e1.waitOn("f", 100);
    expect(v).toBe(1);
    await expect(e1.waitOn("x", 10)).rejects.toThrow(
      "Did not respond in time"
    );
  });
  it("should work lazy", async () => {
    const e1 = new (0, _chunk7L2G4SFKcjs.Emitter)();
    const e2 = new (0, _chunk7L2G4SFKcjs.Emitter)();
    const on1 = lazyListener(e1);
    const on2 = lazyListener(e2);
    await e1.emit("a", 1);
    await e1.emit("b", 2);
    await e2.emit("a", 3);
    expect(await on2("a")).toBe(3);
    expect(await on1("b")).toBe(2);
  });
  it("should expect events", async () => {
    expect.assertions(3);
    const e = new (0, _chunk7L2G4SFKcjs.Emitter)();
    e.on("a", (v) => expect(v).toBe(1));
    e.on("a", (v) => expect(v).toBe(1));
    e.on("b", (v) => expect(v).toBe(1));
    await e.emit("a", 1);
    await e.emit("b", 1);
  });
  it("should expect once", async () => {
    expect.assertions(1);
    const e = new (0, _chunk7L2G4SFKcjs.Emitter)();
    e.once("a", (v) => expect(v).toBe(1));
    void e.emit("a", 1);
    void e.emit("a", 2);
    void e.emit("a", 3);
  });
  it("should mock events", async () => {
    const fn = _vitest.vi.fn();
    const e = new (0, _chunk7L2G4SFKcjs.Emitter)();
    e.on("a", fn);
    e.on("a", fn);
    e.on("b", fn);
    await e.emit("a", 1);
    await e.emit("b", 1);
    expect(fn).toBeCalledTimes(3);
  });
  it("should work with global listener", async () => {
    const fn = _vitest.vi.fn();
    const e = _chunk7L2G4SFKcjs.getGlobalEmitter.call(void 0, );
    e.on("a", fn);
    e.on("a", fn);
    e.on("b", fn);
    await e.emit("a", 1);
    await _chunk7L2G4SFKcjs.getGlobalEmitter.call(void 0, ).emit("b", 2);
    expect(fn).toBeCalledTimes(3);
  });
  it("should respect priorities", async () => {
    const e = new (0, _chunk7L2G4SFKcjs.Emitter)();
    const l = [];
    e.on("p", () => l.push(2), { priority: 100 });
    e.on("p", () => l.push(5), { priority: -1 });
    e.on("p", () => l.push(6), { priority: -2 });
    e.on("p", () => l.push(1), { priority: 110 });
    e.on("p", () => l.push(3));
    e.on("p", () => l.push(4));
    await e.emit("p");
    expect(l).toEqual([1, 2, 3, 4, 5, 6]);
  });
  it("should resolve when the event is emitted", async () => {
    const emitter = new (0, _chunk7L2G4SFKcjs.Emitter)();
    const eventName = "testEvent";
    const eventValue = "Hello, World!";
    const promise = emitter.waitOn(eventName);
    setTimeout(() => {
      emitter.emit(eventName, eventValue);
    }, 100);
    await expect(promise).resolves.toBe(eventValue);
  });
  it("should reject when the timeout is reached", async () => {
    const emitter = new (0, _chunk7L2G4SFKcjs.Emitter)();
    const eventName = "testEvent";
    const promise = emitter.waitOn(eventName, 100);
    await expect(promise).rejects.toThrow("Did not respond in time");
  });
});
//# sourceMappingURL=emitter.spec.cjs.map