import { Type, SchemaDefinitionObject, TypeObject } from './types.cjs';

declare function string<T = string>(): Type<T>;
declare function number<T = number>(): Type<T>;
declare function int<T = number>(): Type<T>;
declare function boolean<T = boolean>(): Type<T>;
declare function object<T extends SchemaDefinitionObject>(tobj: T): TypeObject<T>;
type ExtractLiteral<T> = T extends Type<infer U> ? U : never;
type TransformToUnion<T extends (Type<any>)[]> = T extends Array<infer U> ? ExtractLiteral<U> : never;
declare function union<T extends (Type<any>)[]>(options: T): Type<TransformToUnion<T>>;
type Literal = string | number | bigint | boolean;
declare function literal<T extends Literal>(value: T): Type<T>;
declare function stringLiterals<const T extends readonly string[], O = T[number]>(value: T): Type<O>;

export { boolean, int, literal, number, object, string, stringLiterals, union };
