"use strict";







var _chunk3546LF4Acjs = require('../../chunk-3546LF4A.cjs');
require('../../chunk-VFIICDKU.cjs');
require('../../chunk-PDXKNB3S.cjs');
require('../../chunk-XR7AMYN7.cjs');
require('../../chunk-SLEHBFHV.cjs');
require('../../chunk-KMMN6P2X.cjs');
require('../../chunk-AGQV4BOO.cjs');
require('../../chunk-LURLRIHI.cjs');
require('../../chunk-67Q7IWIS.cjs');
require('../../chunk-B4JXPT6I.cjs');
require('../../chunk-KCBJGJ24.cjs');
require('../../chunk-RPAQV2V5.cjs');
require('../../chunk-SVJWXMAG.cjs');
require('../../chunk-RLHQ6YHC.cjs');
require('../../chunk-MPD2DJAD.cjs');
require('../../chunk-ZGKV237Z.cjs');
require('../../chunk-7BEQHGH5.cjs');
require('../../chunk-VAG3XY63.cjs');
require('../../chunk-FEYF6QXS.cjs');
require('../../chunk-SFVQNT7T.cjs');
require('../../chunk-N7OUNPMM.cjs');
require('../../chunk-Z4FNOCPD.cjs');
require('../../chunk-GWXPD6I7.cjs');
require('../../chunk-N5KTMDVO.cjs');
require('../../chunk-B3U4FDQH.cjs');
require('../../chunk-YELWQAMG.cjs');
require('../../chunk-RHWKNEUH.cjs');
require('../../chunk-DRU33ZUG.cjs');
require('../../chunk-LHP7OTMV.cjs');
require('../../chunk-5BF2LEAU.cjs');
require('../../chunk-6T6PI6XG.cjs');
require('../../chunk-TUWUD5A6.cjs');
require('../../chunk-CUGOCLWN.cjs');


var _chunkW3WUDQICcjs = require('../../chunk-W3WUDQIC.cjs');
require('../../chunk-BXM45HLQ.cjs');
require('../../chunk-HHZVPIBD.cjs');
require('../../chunk-YY4AHBBL.cjs');
require('../../chunk-IMCDDJAJ.cjs');

// src/common/schema/schema.spec.ts
describe("schema", () => {
  it("create schema", async () => {
    const schema = _chunk3546LF4Acjs.object.call(void 0, {
      id: _chunk3546LF4Acjs.string.call(void 0, ).default(() => "123"),
      name: _chunk3546LF4Acjs.string.call(void 0, ),
      age: _chunk3546LF4Acjs.int.call(void 0, ).optional(),
      active: _chunk3546LF4Acjs.boolean.call(void 0, ),
      // status: stringLiterals(['active', 'trialing', 'past_due', 'paused', 'deleted']),
      status: _chunk3546LF4Acjs.string.call(void 0, ),
      obj: _chunk3546LF4Acjs.object.call(void 0, {
        test: _chunk3546LF4Acjs.number.call(void 0, )
      }).optional()
    });
    const sample = {
      name: "Hello",
      status: "active",
      age: 42,
      active: true
    };
    expect(_chunkW3WUDQICcjs.cloneJsonObject.call(void 0, schema)).toMatchInlineSnapshot(`
      Object {
        "_object": Object {
          "active": Object {
            "type": "boolean",
          },
          "age": Object {
            "_integer": true,
            "_optional": true,
            "type": "number",
          },
          "id": Object {
            "type": "string",
          },
          "name": Object {
            "type": "string",
          },
          "obj": Object {
            "_object": Object {
              "test": Object {
                "type": "number",
              },
            },
            "_optional": true,
            "type": "object",
          },
          "status": Object {
            "type": "string",
          },
        },
        "type": "object",
      }
    `);
    expect(schema.parse(sample)).toMatchInlineSnapshot(`
      Object {
        "active": true,
        "age": 42,
        "id": "123",
        "name": "Hello",
        "status": "active",
      }
    `);
    expect(schema.map(sample, (v, s) => {
      if (s.type === "boolean") {
        return v ? "on" : "off";
      }
    })).toMatchInlineSnapshot(`
      Object {
        "active": "on",
        "age": 42,
        "name": "Hello",
        "obj": Object {},
        "status": "active",
      }
    `);
    expect(schema.map(sample, function(v) {
      if (this.type === "boolean") {
        return v ? "yes" : "no";
      }
    })).toMatchInlineSnapshot(`
      Object {
        "active": "yes",
        "age": 42,
        "name": "Hello",
        "obj": Object {},
        "status": "active",
      }
    `);
  });
  it("union", async () => {
    const literals = [
      _chunk3546LF4Acjs.literal.call(void 0, "one"),
      _chunk3546LF4Acjs.literal.call(void 0, "two"),
      _chunk3546LF4Acjs.literal.call(void 0, "three")
    ];
    const schema = _chunk3546LF4Acjs.object.call(void 0, {
      id: _chunk3546LF4Acjs.string.call(void 0, ).default(() => "123").props({
        // someProp: 'someValue',
      }),
      literal: _chunk3546LF4Acjs.literal.call(void 0, "demo"),
      name: _chunk3546LF4Acjs.union.call(void 0, literals)
    });
    const sample = {
      literal: "demo",
      name: "two"
    };
    expect(_chunkW3WUDQICcjs.cloneJsonObject.call(void 0, schema)).toMatchInlineSnapshot(`
      Object {
        "_object": Object {
          "id": Object {
            "_props": Object {},
            "type": "string",
          },
          "literal": Object {
            "type": "string",
          },
          "name": Object {
            "_union": Array [
              Object {
                "type": "string",
              },
              Object {
                "type": "string",
              },
              Object {
                "type": "string",
              },
            ],
            "type": "string",
          },
        },
        "type": "object",
      }
    `);
    expect(schema.parse(sample)).toMatchInlineSnapshot(`
      Object {
        "id": "123",
        "literal": "demo",
        "name": "two",
      }
    `);
  });
});
//# sourceMappingURL=schema.spec.cjs.map