/**
 * @returns Timestamp in miliseconds
 */
declare function getTimestamp(): number;
declare function formatMilliseconds(ms: number): string;
/**
 * Parses the given date candidates and returns the first valid Date object found.
 *
 * @param dateCandidates - The date candidates to parse, which can be either strings or Date objects.
 * @returns The parsed Date object, or undefined if no valid date is found.
 */
declare function parseDate(...dateCandidates: (string | Date)[]): Date | undefined;
/**
 * @returns Timestamp in miliseconds
 */
declare function getPerformanceTimestamp(): number;
declare function duration(): () => string;
/** If you parsed a date without time zone, you may need to shift it to local time */
declare function datetimeToLocal(fromDate: Date): Date;
/** If you parsed a date without time zone, you may need to shift it to UTC time */
declare function datetimeToUTC(fromDate: Date): Date;

export { datetimeToLocal, datetimeToUTC, duration, formatMilliseconds, getPerformanceTimestamp, getTimestamp, parseDate };
